---
stages:
  - "build-cache"
  - "build"
  - "test"
  - "report"
  - "publish"
  - "deploy"

.stage:build-cache:
  stage: "build-cache"

.stage:build:
  stage: "build"

.stage:test:
  stage: "test"

.stage:report:
  stage: "report"

.stage:publish:
  stage: "publish"

.stage:deploy:
  stage: "deploy"

.only:branches:
  only:
    refs:
      - "branches"

.only:main-branch:
  only:
    refs:
      - "main"

.only:release-branch:
  only:
    refs:
      - "branches"
    variables:
      - >
        ($CI_COMMIT_BRANCH =~ /^release-(?:.+-)?\d*\.(?:0|[1-9]\d*)$/)

.only:feature-branch:
  only:
    refs:
      - "branches"
    variables:
      - >
        ($CI_COMMIT_BRANCH !~ /^release-(?:.+-)?\d*\.(?:0|[1-9]\d*)$/) && ($CI_COMMIT_BRANCH != "main")

.only:feature-and-main-branch:
  only:
    refs:
      - "branches"
    variables:
      - >
        ($CI_COMMIT_BRANCH !~ /^release-(?:.+-)?\d*\.(?:0|[1-9]\d*)$/)
